diff --git a/doc/bashref.toc b/doc/bashref.toc
index 73e15f0d..3ed87bc1 100644
--- a/doc/bashref.toc
+++ b/doc/bashref.toc
@@ -129,8 +129,9 @@
 \appendixentry{Copying This Manual}{C}{139}
 \secentry{GNU Free Documentation License}{C}{1}{139}
 \subsecentry{ADDENDUM: How to use this License for your documents}{C}{1}{1}{145}
-\unnumbchapentry{Index of Shell Builtin Commands}{10}{147}
-\unnumbchapentry{Index of Shell Reserved Words}{10}{149}
-\unnumbchapentry{Parameter and Variable Index}{10}{151}
-\unnumbchapentry{Function Index}{10}{153}
-\unnumbchapentry{Concept Index}{10}{155}
+\appendixentry{Indexes}{D}{147}
+\secentry{Index of Shell Builtin Commands}{D}{1}{147}
+\secentry{Index of Shell Reserved Words}{D}{2}{149}
+\secentry{Parameter and Variable Index}{D}{3}{149}
+\secentry{Function Index}{D}{4}{151}
+\secentry{Concept Index}{D}{5}{152}
diff --git a/doc/bashref.vr b/doc/bashref.vr
index 84a11cc6..17bddf90 100644
--- a/doc/bashref.vr
+++ b/doc/bashref.vr
@@ -78,7 +78,7 @@
 \entry{OSTYPE}{65}{\code {OSTYPE}}
 \entry{PIPESTATUS}{65}{\code {PIPESTATUS}}
 \entry{POSIXLY_CORRECT}{65}{\code {POSIXLY_CORRECT}}
-\entry{PPID}{65}{\code {PPID}}
+\entry{PPID}{66}{\code {PPID}}
 \entry{PROMPT_COMMAND}{66}{\code {PROMPT_COMMAND}}
 \entry{PS3}{66}{\code {PS3}}
 \entry{PS4}{66}{\code {PS4}}
diff --git a/doc/bashref.vrs b/doc/bashref.vrs
index 84e1a811..24500122 100644
--- a/doc/bashref.vrs
+++ b/doc/bashref.vrs
@@ -117,7 +117,7 @@
 \entry {\code {PATH}}{59}
 \entry {\code {PIPESTATUS}}{65}
 \entry {\code {POSIXLY_CORRECT}}{65}
-\entry {\code {PPID}}{65}
+\entry {\code {PPID}}{66}
 \entry {\code {PROMPT_COMMAND}}{66}
 \entry {\code {PS1}}{59}
 \entry {\code {PS2}}{59}
diff --git a/doc/builtins.0 b/doc/builtins.0
index 3a635eae..0e0a3e83 100644
--- a/doc/builtins.0
+++ b/doc/builtins.0
@@ -631,11 +631,15 @@ BBAASSHH BBUUIILLTTIINN CCOOMMMMAANNDDSS
                      the _a_r_g_s are added.
 
               If the HHIISSTTTTIIMMEEFFOORRMMAATT is set, the time stamp information associ-
-              ated with each history entry is written  to  the  history  file.
-              The  return  value is 0 unless an invalid option is encountered,
-              an error occurs while reading or writing the  history  file,  an
-              invalid  _o_f_f_s_e_t is supplied as an argument to --dd, or the history
-              expansion supplied as an argument to --pp fails.
+              ated with each history entry is written  to  the  history  file,
+              marked  with  the  history  comment character.  When the history
+              file is read, lines beginning with the history comment character
+              followed  immediately  by  a digit are interpreted as timestamps
+              for the previous history line.  The return value is 0 unless  an
+              invalid  option is encountered, an error occurs while reading or
+              writing the history file, an invalid _o_f_f_s_e_t is  supplied  as  an
+              argument to --dd, or the history expansion supplied as an argument
+              to --pp fails.
 
        jjoobbss [--llnnpprrss] [ _j_o_b_s_p_e_c ... ]
        jjoobbss --xx _c_o_m_m_a_n_d [ _a_r_g_s ... ]
diff --git a/doc/builtins.ps b/doc/builtins.ps
index 2b4d84cb..5e90635e 100644
--- a/doc/builtins.ps
+++ b/doc/builtins.ps
@@ -1,6 +1,6 @@
 %!PS-Adobe-3.0
 %%Creator: groff version 1.19.1
-%%CreationDate: Tue Jan  2 10:25:15 2007
+%%CreationDate: Tue Jan 16 11:15:09 2007
 %%DocumentNeededResources: font Times-Roman
 %%+ font Times-Bold
 %%+ font Times-Italic
diff --git a/doc/rbash.ps b/doc/rbash.ps
index 99eef811..fbbc5d96 100644
--- a/doc/rbash.ps
+++ b/doc/rbash.ps
@@ -1,6 +1,6 @@
 %!PS-Adobe-3.0
 %%Creator: groff version 1.19.1
-%%CreationDate: Tue Jan  2 10:25:15 2007
+%%CreationDate: Tue Jan 16 11:15:09 2007
 %%DocumentNeededResources: font Times-Roman
 %%+ font Times-Bold
 %%DocumentSuppliedResources: procset grops 1.19 1
diff --git a/examples/scripts/timeout2 b/examples/scripts/timeout2
new file mode 100755
index 00000000..2c6fb779
--- /dev/null
+++ b/examples/scripts/timeout2
@@ -0,0 +1,29 @@
+#!/bin/sh
+
+# Author: P@draigBrady.com
+# V1.0  : Nov  3 2006
+#
+#  Execute a command with a timeout.
+#  If the timeout occurs the exit status is 128
+#
+#  Note there is an asynchronous equivalent of this
+#  script packaged with bash (under /usr/share/doc/ in my distro),
+#  which I only noticed after writing this.
+
+if [ "$#" -lt "2" ]; then
+    echo "Usage:   `basename $0` timeout_in_seconds command" >&2
+    echo "Example: `basename $0` 2 sleep 3 || echo timeout" >&2
+    exit 1
+fi
+
+cleanup()
+{
+    kill %1 2>/dev/null             #kill sleep $timeout if running
+    kill %2 2>/dev/null && exit 128 #kill monitored job if running
+}
+
+set -m               #enable job control
+trap "cleanup" 17    #cleanup after timeout or command
+timeout=$1 && shift  #first param is timeout in seconds
+sleep $timeout&      #start the timeout
+"$@"                 #start the job
diff --git a/lib/sh/shmatch.c.debug b/lib/sh/shmatch.c.debug
new file mode 100644
index 00000000..2459ddaf
--- /dev/null
+++ b/lib/sh/shmatch.c.debug
@@ -0,0 +1,127 @@
+/* Copyright (C) 2003 Free Software Foundation, Inc.
+
+   This file is part of GNU Bash, the Bourne Again SHell.
+
+   Bash is free software; you can redistribute it and/or modify it under
+   the terms of the GNU General Public License as published by the Free
+   Software Foundation; either version 2, or (at your option) any later
+   version.
+
+   Bash is distributed in the hope that it will be useful, but WITHOUT ANY
+   WARRANTY; without even the implied warranty of MERCHANTABILITY or
+   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+   for more details.
+
+   You should have received a copy of the GNU General Public License along
+   with Bash; see the file COPYING.  If not, write to the Free Software
+   Foundation, 59 Temple Place, Suite 330, Boston, MA 02111 USA. */
+
+/*
+ * shmatch.c -- shell interface to posix regular expression matching.
+ */
+
+#ifdef HAVE_CONFIG_H
+#  include <config.h>
+#endif
+
+#if defined (HAVE_POSIX_REGEXP)
+
+#ifdef HAVE_UNISTD_H
+#  include <unistd.h>
+#endif
+
+#include "bashansi.h"
+
+#include <stdio.h>
+#include <regex.h>
+
+#include "shell.h"
+#include "variables.h"
+#include "externs.h"
+
+extern int glob_ignore_case, match_ignore_case;
+
+int
+sh_regmatch (string, pattern, flags)
+     const char *string;
+     const char *pattern;
+     int flags;
+{
+  regex_t regex = { 0 };
+  regmatch_t *matches;
+  int rflags;
+#if defined (ARRAY_VARS)
+  SHELL_VAR *rematch;
+  ARRAY *amatch;
+  int subexp_ind;
+  char *subexp_str;
+  int subexp_len;
+#endif
+  int result, r;
+
+#if defined (ARRAY_VARS)
+  rematch = (SHELL_VAR *)NULL;
+#endif
+  
+  rflags = REG_EXTENDED;
+  if (glob_ignore_case || match_ignore_case)
+    rflags |= REG_ICASE;
+#if !defined (ARRAY_VARS)
+  rflags |= REG_NOSUB;
+#endif
+
+  if (regcomp (&regex, pattern, rflags))
+    return 2;		/* flag for printing a warning here. */
+
+#if defined (ARRAY_VARS)
+  matches = (regmatch_t *)malloc (sizeof (regmatch_t) * (regex.re_nsub + 1));
+#else
+  matches = NULL;
+#endif
+
+  if (r = regexec (&regex, string, regex.re_nsub + 1, matches, 0))
+    result = EXECUTION_FAILURE;
+  else
+    result = EXECUTION_SUCCESS;		/* match */
+
+  if (r != 0) {
+  	char	errbuf[1024];
+ 
+	regerror(r, &regex, errbuf, sizeof(errbuf));
+	fprintf(stderr, "sh_regmatch: match failed: %s\n", errbuf);
+  }
+
+#if defined (ARRAY_VARS)
+  subexp_len = strlen (string) + 10;
+  subexp_str = malloc (subexp_len + 1);
+
+  /* Store the parenthesized subexpressions in the array BASH_REMATCH.
+     Element 0 is the portion that matched the entire regexp.  Element 1
+     is the part that matched the first subexpression, and so on. */
+  unbind_variable ("BASH_REMATCH");
+  rematch = make_new_array_variable ("BASH_REMATCH");
+  amatch = array_cell (rematch);
+
+  if ((flags & SHMAT_SUBEXP) && result == EXECUTION_SUCCESS && subexp_str)
+    {
+      for (subexp_ind = 0; subexp_ind <= regex.re_nsub; subexp_ind++)
+	{
+	  memset (subexp_str, 0, subexp_len);
+	  strncpy (subexp_str, string + matches[subexp_ind].rm_so,
+		     matches[subexp_ind].rm_eo - matches[subexp_ind].rm_so);
+	  array_insert (amatch, subexp_ind, subexp_str);
+	}
+    }
+
+  VSETATTR (rematch, att_readonly);
+
+  free (subexp_str);
+  free (matches);
+#endif /* ARRAY_VARS */
+
+  regfree (&regex);
+
+  return result;
+}
+
+#endif /* HAVE_POSIX_REGEXP */
diff --git a/lib/sh/shmatch.c.save b/lib/sh/shmatch.c.save
new file mode 100644
index 00000000..f03a2ee5
--- /dev/null
+++ b/lib/sh/shmatch.c.save
@@ -0,0 +1,120 @@
+/* Copyright (C) 2003 Free Software Foundation, Inc.
+
+   This file is part of GNU Bash, the Bourne Again SHell.
+
+   Bash is free software; you can redistribute it and/or modify it under
+   the terms of the GNU General Public License as published by the Free
+   Software Foundation; either version 2, or (at your option) any later
+   version.
+
+   Bash is distributed in the hope that it will be useful, but WITHOUT ANY
+   WARRANTY; without even the implied warranty of MERCHANTABILITY or
+   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+   for more details.
+
+   You should have received a copy of the GNU General Public License along
+   with Bash; see the file COPYING.  If not, write to the Free Software
+   Foundation, 59 Temple Place, Suite 330, Boston, MA 02111 USA. */
+
+/*
+ * shmatch.c -- shell interface to posix regular expression matching.
+ */
+
+#ifdef HAVE_CONFIG_H
+#  include <config.h>
+#endif
+
+#if defined (HAVE_POSIX_REGEXP)
+
+#ifdef HAVE_UNISTD_H
+#  include <unistd.h>
+#endif
+
+#include "bashansi.h"
+
+#include <stdio.h>
+#include <regex.h>
+
+#include "shell.h"
+#include "variables.h"
+#include "externs.h"
+
+extern int glob_ignore_case, match_ignore_case;
+
+int
+sh_regmatch (string, pattern, flags)
+     const char *string;
+     const char *pattern;
+     int flags;
+{
+  regex_t regex = { 0 };
+  regmatch_t *matches;
+  int rflags;
+#if defined (ARRAY_VARS)
+  SHELL_VAR *rematch;
+  ARRAY *amatch;
+  int subexp_ind;
+  char *subexp_str;
+  int subexp_len;
+#endif
+  int result;
+
+#if defined (ARRAY_VARS)
+  rematch = (SHELL_VAR *)NULL;
+#endif
+  
+  rflags = REG_EXTENDED;
+  if (glob_ignore_case || match_ignore_case)
+    rflags |= REG_ICASE;
+#if !defined (ARRAY_VARS)
+  rflags |= REG_NOSUB;
+#endif
+
+  if (regcomp (&regex, pattern, rflags))
+    return 2;		/* flag for printing a warning here. */
+
+#if defined (ARRAY_VARS)
+  matches = (regmatch_t *)malloc (sizeof (regmatch_t) * (regex.re_nsub + 1));
+#else
+  matches = NULL;
+#endif
+
+  if (regexec (&regex, string, regex.re_nsub + 1, matches, 0))
+    result = EXECUTION_FAILURE;
+  else
+    result = EXECUTION_SUCCESS;		/* match */
+
+#if defined (ARRAY_VARS)
+  subexp_len = strlen (string) + 10;
+  subexp_str = malloc (subexp_len + 1);
+
+  /* Store the parenthesized subexpressions in the array BASH_REMATCH.
+     Element 0 is the portion that matched the entire regexp.  Element 1
+     is the part that matched the first subexpression, and so on. */
+  unbind_variable ("BASH_REMATCH");
+  rematch = make_new_array_variable ("BASH_REMATCH");
+  amatch = array_cell (rematch);
+
+  if ((flags & SHMAT_SUBEXP) && result == EXECUTION_SUCCESS && subexp_str)
+    {
+      for (subexp_ind = 0; subexp_ind <= regex.re_nsub; subexp_ind++)
+	{
+	  memset (subexp_str, 0, subexp_len);
+	  strncpy (subexp_str, string + matches[subexp_ind].rm_so,
+		     matches[subexp_ind].rm_eo - matches[subexp_ind].rm_so);
+	  array_insert (amatch, subexp_ind, subexp_str);
+	}
+    }
+
+  VSETATTR (rematch, att_readonly);
+
+  free (subexp_str);
+  free (matches);
+#endif /* ARRAY_VARS */
+
+  regfree (&regex);
+
+  return result;
+}
+
+#endif /* HAVE_POSIX_REGEXP */
